<?php

namespace DNW\Skills;

class RatingContainer
{
    private HashMap $playerToRating;

    public function __construct()
    {
        $this->playerToRating = new HashMap();
    }

    public function getRating(Player $player): Rating
    {
        return $this->playerToRating->getValue($player);
    }

    public function setRating(Player $player, Rating $rating): HashMap
    {
        return $this->playerToRating->setValue($player, $rating);
    }

    public function getAllPlayers(): array
    {
        return $this->playerToRating->getAllKeys();
    }

    public function getAllRatings(): array
    {
        return $this->playerToRating->getAllValues();
    }

    public function count(): int
    {
        return $this->playerToRating->count();
    }
}
